#ifndef BRESENHAM_H
#define BRESENHAM_H 1
#include "project_utilities.h"

BEGIN_C_DECLARATIONS

typedef struct Bresenham_line * bresenham_linep_t;

bresenham_linep_t bresenham_from_s_coord (int32_t first_col,
                                          int32_t first_row,
                                          int32_t last_col,
                                          int32_t last_row);

int bresenham_next_s (bresenham_linep_t bline,
                      int32_t * col, int32_t * row);

bresenham_linep_t bresenham_from_coord (uint32_t first_col,
                                        uint32_t first_row,
                                        uint32_t last_col,
                                        uint32_t last_row);

int bresenham_next (bresenham_linep_t bline,
                    uint32_t * col, uint32_t * row);

void demolish_bresenham (bresenham_linep_t * blinehandle);

END_C_DECLARATIONS

#endif /* !BRESENHAM_H */
